import { select, scaleLinear, max } from 'd3';
import { rand } from './dontlook';


const svg = select('svg');
const height = +svg.attr('height');
const width = +svg.attr('width');

const data = [{x: 0, y: 20}, 
            {x: 150, y: 150}, 
            {x: 300, y: 100}, 
            {x: 450, y: 20}, 
            {x: 600, y: 130}]

const y = scaleLinear()
  .range([10, height-50]);

const x = scaleLinear()
  .range([10, width-100]);

x.domain([0, 800]);
y.domain([0, 800]);

const update = (data) => {
  
  const circles = svg.selectAll('circle')
  	.data(data);
  	
  circles
    .enter()
  		.append('circle')
  		.attr('fill', 'steelblue')
  		.attr('r', 6)
   		// Il faut mettre tous les attributs qui peuvent changer
  		// après le merge.
  		.merge(circles)
  		.attr('cx', function(d) { return x(d.x); })
  		.attr('cy', function(d) { return x(d.y); });
  
  // Si il y a des circles qui "sortent" de l'espace.
  circles
    .exit()
    .remove();
  

};


update(data);



d3.selectAll('.button_click').on(
  'click',
  function () {
    var buttonID = d3.select(this).attr('id');

    if (buttonID == 'pop') {
      // On enlève une valeur dans le tableau.
      data.pop();
      // Sur cet appel, il n'y aura rien à "entrer" dans le join.
      update(data);
    }
    
    if (buttonID == 'change') {
      // On modifie une valeur dans les données.
      data.splice(rand(0, data.length-1), 1, {x: rand(100, 400), y: rand(100, 400)});
      // Cette fois, le cercle existe bien pour l'échantillon de données,
      // nous souhaitons "mettre à jour" le cercle.
      update(data);
    }
  }